#include <boost/thread.hpp>
#include <stdlib.h>
#include <stdio.h>
#include <ctime>
#include "MyCounter.h"

/*
 *	This program creates one boost thread that increases a MyCounter object until a given goal
 *	once using a mutex lock and once without
 */

  
void threadFunction(MyCounter *mc, int mode)
{
  bool result = false;

  while(!result)
  {
    if(mode == 0){
      result = mc->Increase();
    }else
    {
      result = mc->safeIncrease();
    }
  }
}


long launchThreads(int threadNumber, int mode, MyCounter *mc)
{
   struct timeval start, end;

   long mtime, seconds, useconds;  
   
   boost::thread* threads[threadNumber];
   
  // Start the timer
  gettimeofday(&start, NULL);
  
  for(int i = 0; i < threadNumber; i++)
  {
    threads[i] = new boost::thread(threadFunction, mc, mode);
  }
  for(int i = 0; i < threadNumber; i++)
  {
    threads[i]->join();
  }
  // Stop the timer
  gettimeofday(&end, NULL);
  
  seconds  = end.tv_sec  - start.tv_sec;
  useconds = end.tv_usec - start.tv_usec;
  mtime = ((seconds) * 1000 + useconds/1000.0) + 0.5; 
  
  return(mtime);
}


int main(int argc, char* argv[])
{

  
  int goal = atoi(argv[1]);
  
  int threadNumber = 1;
  
  long elapsedTime;
 
  
  MyCounter *mc = new MyCounter(goal);

  elapsedTime = launchThreads(threadNumber, 0, mc);
  
  printf("Elapsed time (unlocked): %ld ms\n", elapsedTime);
 
  mc->value = 0;
  
  elapsedTime = launchThreads(threadNumber, 1, mc);
  
  printf("Elapsed time (locked): %ld ms\n", elapsedTime);
}

