#include <boost/thread.hpp>
#include <stdlib.h>
#include <stdio.h>
#include <ctime>

/*
 *	This program runs the thread creation test several times for an increasing number of threads
 */

double launchThreads(int number);

void threadFunction()
{
  int i;

  for(i = 0; i < 1000; i++)
  {

  }
}

int main(int argc, char* argv[])
{
  int steps[] = {100, 500, 1000, 1500, 2000, 5000, 10000, 50000, 100000, 500000, 1000000};
  int numOfSteps = 11;

  for(int i = 0; i < numOfSteps; i++)
  {
    double *results = new double[3];
    
    results[0] = launchThreads(steps[i]);
    results[1] = launchThreads(steps[i]);
    results[2] = launchThreads(steps[i]);        
    
    double actualResult = (results[0] + results[1] + results[2])/3;
    
    printf("%d\tthreads: \t%4.2f ms  \t(%4.2f %4.2f %4.2f)\n"
           , steps[i], actualResult, results[0], results[1], results[2]);
  }
}

double launchThreads(int number)
{
  clock_t start, end;
  
  // Start the timer
  start = clock();
  for(int i = 0; i < number; i++)
  {
    boost::thread myThread(threadFunction);
  }
  // Stop the timer
  end = clock(); 
  
  return(((double)(end - start)/CLOCKS_PER_SEC)*1000);
}
