// This program creats a thread that increases a Counter object up to a given goal and measures the time


public class LockingTest {
  
  public static void main(String[] args) throws java.lang.InterruptedException
  {
    int goal = Integer.parseInt(args[0]);
    MyCounter counter = new MyCounter(goal);
    int threadNumber = 1;
      
    long result = launchThreads(threadNumber, 0, counter);
    System.out.println("Goal: "+goal + "\tElapsed time (unlocked): " + result + " ms");
    
    // Run same test with sync
    result = launchThreads(threadNumber, 1, counter);
    System.out.println("\t\tElapsed time (locked): " + result + " ms");
  
  }
  
  public static long launchThreads(int threadNumber, int mode, MyCounter counter)
  		throws java.lang.InterruptedException
  {
  
    CountingThread[] cts = new CountingThread[threadNumber];
    counter.value = 0;
    long start = System.currentTimeMillis();
    for(int i = 0; i < threadNumber; i++)
    {
      cts[i] = new CountingThread(counter, mode);
      cts[i].start();
    }
    for(int i = 0; i < threadNumber; i++)
    {
      cts[i].join();
    }
    long end = System.currentTimeMillis();    
    
    return(end - start);
  }
}
