//	This program performs the Locking test several times for an increasing goal

public class LockingTestSeries {
  
  public static void main(String[] args) throws java.lang.InterruptedException
  {
    MyCounter counter = new MyCounter(0);
    int threadNumber = 1;
    
    int[] steps = {10000, 50000, 100000, 500000, 1000000, 10000000, 100000000, 500000000};
    
    long result = 0;
    for(int i = 0; i < steps.length; i++){
      
      counter.goal = steps[i];
      
      result = launchThreads(threadNumber, 0, counter);
      System.out.println("Goal: "+steps[i] + "\tElapsed time (unlocked): " + result + " ms");
    
      // Run same test with sync
      result = launchThreads(threadNumber, 1, counter);
      System.out.println("\t\tElapsed time (locked): " + result + " ms\n");
  
  }
}
  public static long launchThreads(int threadNumber, int mode, MyCounter counter)
  		throws java.lang.InterruptedException
  {
  
    CountingThread[] cts = new CountingThread[threadNumber];
    counter.value = 0;
    long start = System.currentTimeMillis();
    for(int i = 0; i < threadNumber; i++)
    {
      cts[i] = new CountingThread(counter, mode);
      cts[i].start();
    }
    for(int i = 0; i < threadNumber; i++)
    {
      cts[i].join();
    }
    long end = System.currentTimeMillis();    
    
    return(end - start);
  }
}
